<?php

declare(strict_types=1);

namespace App\Domain\AIPD\Form\Type;

use App\Domain\AIPD\Dictionary\ReponseMesureProtectionDictionary;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\OptionsResolver\Options;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ReponseDictionaryType extends AbstractType
{
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setRequired('aipd');
        $choices = function (Options $options) {
            $choices = (new ReponseMesureProtectionDictionary($options['aipd']))->getValues();

            return array_flip($choices);
        };

        $resolver
            ->setDefault('choices', $choices)
        ;
    }

    public function setDefaultOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            // default form options
            'aipd' => null,
        ]);
    }

    public function getParent(): ?string
    {
        return ChoiceType::class;
    }
}
